
local Set = Object.SetProperty
local Get = Object.GetProperty
local Find = Object.GetNearbyObjects
local timeTot = 0
local timeAnim = 0

-------------------- Find Stuff -------------------------

function FindMyCrane()
    local nearbyObject = Find("GantryCrane2Hook",50)
	if next(nearbyObject) then
		for thatHook, distance in pairs(nearbyObject) do
			if thatHook.HomeUID==this.HomeUID then
				MyHook=thatHook
			end
		end
	end
    nearbyObject = Find("GantryCrane2Wheel",50)
	if next(nearbyObject) then
		for thatCraneWheel, distance in pairs(nearbyObject) do
			if thatCraneWheel.HomeUID==this.HomeUID and thatCraneWheel.Pos.x<this.Pos.x then
				MyCraneWheelLeft=thatCraneWheel
			end
			if thatCraneWheel.HomeUID==this.HomeUID and thatCraneWheel.Pos.x>this.Pos.x then
				MyCraneWheelRight=thatCraneWheel
			end
		end
	end
	nearbyObject = nil
	
	timePerUpdate = 2 / this.TimeWarp
end

function FindMyCargo()
    local nearbyObject = Find(MyHook,"Limo2OnCrane",3)
	if next(nearbyObject) then
		for thatCargo, distance in pairs(nearbyObject) do
			MyCargo = thatCargo
			cargoFound = true
			nearbyObject=nil
			break
		end
	else
		nearbyObject=nil
		local nearbyObject = Find(MyHook,"Limo2EngineOnCrane",3)
		if next(nearbyObject) then
			for thatCargo, distance in pairs(nearbyObject) do
				MyCargo = thatCargo
				cargoFound = true
				nearbyObject=nil
				break
			end
		else
			cargoFound = false
			nearbyObject=nil
		end
	end
end
	
-------------------- Done finding  ----------------------


-------------------- Animate crane ----------------------

function AnimCrane()
	if timeAnim > 0.25 then
		if MyHook.SubType==1 then MyHook.SubType=2 else MyHook.SubType=1 end
		timeAnim = 0
	end
end

function AnimWheel()
	if timeAnim > 0.25 then
		if MyHook.SubType==1 then MyHook.SubType=2 else MyHook.SubType=1 end
		if MyCraneWheelLeft.SubType==1 then
			MyCraneWheelLeft.SubType=0
			MyCraneWheelRight.SubType=0
		else
			MyCraneWheelLeft.SubType=1
			MyCraneWheelRight.SubType=1
		end
		timeAnim = 0
	end
end

-------------------- End Animation ----------------------


-------------------- Move Crane -------------------------

function MoveTheCrane()
	if cargoFound == nil then FindMyCargo() end
	local reachedY = false
	local reachedX = false
	timePerUpdate = 0
	Set(this,"CraneInPosition",false)
	if Get(this,"CraneInPosition") == false then
		if this.Pos.y >= this.MoveToY-0.01 and this.Pos.y <= this.MoveToY+0.01 then
			Object.ApplyVelocity(this,0,0)
			Object.ApplyVelocity(MyHook,0,0)
			Object.ApplyVelocity(MyCraneWheelLeft,0,0)
			Object.ApplyVelocity(MyCraneWheelRight,0,0)
			if cargoFound == true then Object.ApplyVelocity(MyCargo,0,0,false) end
			this.Pos.y = Get(this,"MoveToY")
			reachedY=true
		else
			reachedY=false
			AnimWheel()
			if this.Pos.y >= this.MoveToY then
				if this.Pos.y - this.MoveToY > this.CraneSpeed then
					Object.ApplyVelocity(this,0,-this.CraneSpeed)
					Object.ApplyVelocity(MyHook,0,-this.CraneSpeed)
					Object.ApplyVelocity(MyCraneWheelLeft,0,-this.CraneSpeed)
					Object.ApplyVelocity(MyCraneWheelRight,0,-this.CraneSpeed)
					if cargoFound == true then Object.ApplyVelocity(MyCargo,0,-this.CraneSpeed,false) end
				elseif this.Pos.y - this.MoveToY > 0 then
					Object.ApplyVelocity(this,0,-(this.Pos.y+0.5 - this.MoveToY))
					Object.ApplyVelocity(MyHook,0,-(this.Pos.y+0.5 - this.MoveToY))
					Object.ApplyVelocity(MyCraneWheelLeft,0,-(this.Pos.y+0.5 - this.MoveToY))
					Object.ApplyVelocity(MyCraneWheelRight,0,-(this.Pos.y+0.5 - this.MoveToY))
					if cargoFound == true then Object.ApplyVelocity(MyCargo,0,-(this.Pos.y+0.5 - this.MoveToY),false) end
				else
					--print("reachedY=true")
					Object.ApplyVelocity(this,0,0)
					Object.ApplyVelocity(MyHook,0,0)
					Object.ApplyVelocity(MyCraneWheelLeft,0,0)
					Object.ApplyVelocity(MyCraneWheelRight,0,0)
					if cargoFound == true then Object.ApplyVelocity(MyCargo,0,0,false) end
					this.Pos.y = Get(this,"MoveToY")
					reachedY=true
				end
			elseif this.Pos.y <= this.MoveToY then
				if this.MoveToY - this.Pos.y > this.CraneSpeed then
					Object.ApplyVelocity(this,0,this.CraneSpeed)
					Object.ApplyVelocity(MyHook,0,this.CraneSpeed)
					Object.ApplyVelocity(MyCraneWheelLeft,0,this.CraneSpeed)
					Object.ApplyVelocity(MyCraneWheelRight,0,this.CraneSpeed)
					if cargoFound == true then Object.ApplyVelocity(MyCargo,0,this.CraneSpeed,false) end
				elseif this.MoveToY - this.Pos.y > 0 then
					Object.ApplyVelocity(this,0,this.MoveToY+0.5 - this.Pos.y)
					Object.ApplyVelocity(MyHook,0,this.MoveToY+0.5 - this.Pos.y)
					Object.ApplyVelocity(MyCraneWheelLeft,0,this.MoveToY+0.5 - this.Pos.y)
					Object.ApplyVelocity(MyCraneWheelRight,0,this.MoveToY+0.5 - this.Pos.y)
					if cargoFound == true then Object.ApplyVelocity(MyCargo,0,this.MoveToY+0.5 - this.Pos.y,false) end
				else
					--print("reachedY=true")
					Object.ApplyVelocity(this,0,0)
					Object.ApplyVelocity(MyHook,0,0)
					Object.ApplyVelocity(MyCraneWheelLeft,0,0)
					Object.ApplyVelocity(MyCraneWheelRight,0,0)
					if cargoFound == true then Object.ApplyVelocity(MyCargo,0,0,false) end
					this.Pos.y = Get(this,"MoveToY")
					reachedY=true
				end
			end
		end
		if reachedY == true then
			if MyHook.Pos.x>=this.MoveToX-0.01 and MyHook.Pos.x<=this.MoveToX+0.01 then
				Object.ApplyVelocity(MyHook,0,0)
				if cargoFound == true then 
					Object.ApplyVelocity(MyCargo,0,0,false)
				end
				reachedX = true
			else
				reachedX = false
				AnimCrane()
				if MyHook.Pos.x > this.MoveToX then
					if MyHook.Pos.x - this.MoveToX > this.CraneSpeed then
						Object.ApplyVelocity(MyHook,-this.CraneSpeed,0)
						if cargoFound == true then Object.ApplyVelocity(MyCargo,-this.CraneSpeed,0,false) end
					elseif MyHook.Pos.x - this.MoveToX > 0 then
						Object.ApplyVelocity(MyHook,-(MyHook.Pos.x+0.5 - this.MoveToX),0)
						if cargoFound == true then Object.ApplyVelocity(MyCargo,-(MyHook.Pos.x+0.5 - this.MoveToX),0,false) end
					else
						Object.ApplyVelocity(MyHook,0,0)
						if cargoFound == true then Object.ApplyVelocity(MyCargo,0,0,false) end
						this.Pos.x = Get(this,"MoveToX")
						reachedX = true
					end
					MyHook.Triggered = 2
				elseif MyHook.Pos.x < this.MoveToX then
					if this.MoveToX - MyHook.Pos.x > this.CraneSpeed then
						Object.ApplyVelocity(MyHook,this.CraneSpeed,0)
						if cargoFound == true then Object.ApplyVelocity(MyCargo,this.CraneSpeed,0,false) end
					elseif this.MoveToX - MyHook.Pos.x > 0 then
						Object.ApplyVelocity(MyHook,this.MoveToX+0.5 - MyHook.Pos.x,0)
						if cargoFound == true then Object.ApplyVelocity(MyCargo,this.MoveToX+0.5 - MyHook.Pos.x,0,false) end
					else
						Object.ApplyVelocity(MyHook,0,0)
						if cargoFound == true then Object.ApplyVelocity(MyCargo,0,0,false) end
						this.Pos.x = Get(this,"MoveToX")
						reachedX = true
					end
				end
			end
		end
		if reachedX == true and reachedY == true then
			MyHook.SubType=0
			Set(this,"CraneInPosition",true)
			Set(this,"MoveTheCrane",false)
			cargoFound = nil
			if Get(this,"MoveToCentre") == false then Set(MyHook,this.GiveJob,true) end
		end
	end
end

function MoveToCentre()
	if Get(this,"init") == nil then
		Set(this,"CraneInPosition",false)
		if MyHook.Pos.x>=this.ParkX-0.15 and MyHook.Pos.x<=this.ParkX+0.15 then
			if MyHook.Pos.x < this.MoveToX then
				--print("move to right roadside")
				Set(this,"TmpX",this.MoveRightX)
			end
			if MyHook.Pos.x > this.MoveToX then
				--print("move to left roadside")
				Set(this,"TmpX",this.MoveLeftX)
			end
		else
			if MyHook.Pos.x < this.MoveLeftX then
				--print("move to left roadside")
				Set(this,"TmpX",this.MoveLeftX)
			end
			if MyHook.Pos.x > this.MoveRightX then
				--print("move to right roadside")
				Set(this,"TmpX",this.MoveRightX)
			end
		end
		Set(this,"TmpY",this.Pos.y)
		Set(this,"init","done")
	end
	if cargoFound == nil then FindMyCargo() end
	local reachedY = false
	local reachedX = false
	timePerUpdate = 0
	if this.Pos.y >= this.TmpY-0.01 and this.Pos.y <= this.TmpY+0.01 then
		Object.ApplyVelocity(this,0,0)
		Object.ApplyVelocity(MyHook,0,0)
		Object.ApplyVelocity(MyCraneWheelLeft,0,0)
		Object.ApplyVelocity(MyCraneWheelRight,0,0)
		if cargoFound == true then Object.ApplyVelocity(MyCargo,0,0,false) end
		this.Pos.y = Get(this,"TmpY")
		reachedY=true
	else
		reachedY=false
		AnimWheel()
		if this.Pos.y >= this.TmpY then
			if this.Pos.y - this.TmpY > this.CraneSpeed then
				Object.ApplyVelocity(this,0,-this.CraneSpeed)
				Object.ApplyVelocity(MyHook,0,-this.CraneSpeed)
				Object.ApplyVelocity(MyCraneWheelLeft,0,-this.CraneSpeed)
				Object.ApplyVelocity(MyCraneWheelRight,0,-this.CraneSpeed)
				if cargoFound == true then Object.ApplyVelocity(MyCargo,0,-this.CraneSpeed,false) end
			elseif this.Pos.y - this.TmpY > 0 then
				Object.ApplyVelocity(this,0,-(this.Pos.y+0.5 - this.TmpY))
				Object.ApplyVelocity(MyHook,0,-(this.Pos.y+0.5 - this.TmpY))
				Object.ApplyVelocity(MyCraneWheelLeft,0,-(this.Pos.y+0.5 - this.TmpY))
				Object.ApplyVelocity(MyCraneWheelRight,0,-(this.Pos.y+0.5 - this.TmpY))
				if cargoFound == true then Object.ApplyVelocity(MyCargo,0,-(this.Pos.y+0.5 - this.TmpY),false) end
			else
				--print("reachedY=true")
				Object.ApplyVelocity(this,0,0)
				Object.ApplyVelocity(MyHook,0,0)
				Object.ApplyVelocity(MyCraneWheelLeft,0,0)
				Object.ApplyVelocity(MyCraneWheelRight,0,0)
				if cargoFound == true then Object.ApplyVelocity(MyCargo,0,0,false) end
				this.Pos.y = Get(this,"TmpY")
				reachedY=true
			end
		elseif this.Pos.y <= this.TmpY then
			if this.TmpY - this.Pos.y > this.CraneSpeed then
				Object.ApplyVelocity(this,0,1.5)
				Object.ApplyVelocity(MyHook,0,1.5)
				Object.ApplyVelocity(MyCraneWheelLeft,0,this.CraneSpeed)
				Object.ApplyVelocity(MyCraneWheelRight,0,this.CraneSpeed)
				if cargoFound == true then Object.ApplyVelocity(MyCargo,0,this.CraneSpeed,false) end
			elseif this.TmpY - this.Pos.y > 0 then
				Object.ApplyVelocity(this,0,this.TmpY+0.5 - this.Pos.y)
				Object.ApplyVelocity(MyHook,0,this.TmpY+0.5 - this.Pos.y)
				Object.ApplyVelocity(MyCraneWheelLeft,0,this.TmpY+0.5 - this.Pos.y)
				Object.ApplyVelocity(MyCraneWheelRight,0,this.TmpY+0.5 - this.Pos.y)
				if cargoFound == true then Object.ApplyVelocity(MyCargo,0,this.TmpY+0.5 - this.Pos.y,false) end
			else
				--print("reachedY=true")
				Object.ApplyVelocity(this,0,0)
				Object.ApplyVelocity(MyHook,0,0)
				Object.ApplyVelocity(MyCraneWheelLeft,0,0)
				Object.ApplyVelocity(MyCraneWheelRight,0,0)
				if cargoFound == true then Object.ApplyVelocity(MyCargo,0,0,false) end
				this.Pos.y = Get(this,"TmpY")
				reachedY=true
			end
		end
	end
	if reachedY == true then
		if MyHook.Pos.x>=this.TmpX-0.01 and MyHook.Pos.x<=this.TmpX+0.01 then
			Object.ApplyVelocity(MyHook,0,0)
			if cargoFound == true then 
				Object.ApplyVelocity(MyCargo,0,0,false)
			end
			MyHook.Pos.x = Get(this,"TmpX")
			reachedX = true
		else
			reachedX = false
			AnimCrane()
			if MyHook.Pos.x > this.TmpX then
				if MyHook.Pos.x - this.MoveToX > this.CraneSpeed then
					Object.ApplyVelocity(MyHook,-this.CraneSpeed,0)
					if cargoFound == true then Object.ApplyVelocity(MyCargo,-this.CraneSpeed,0,false) end
				elseif MyHook.Pos.x - this.MoveToX > 0 then
					Object.ApplyVelocity(MyHook,-(MyHook.Pos.x+0.5 - this.TmpX),0)
					if cargoFound == true then Object.ApplyVelocity(MyCargo,-(MyHook.Pos.x+0.5 - this.TmpX),0,false) end
				else
					Object.ApplyVelocity(MyHook,0,0)
					if cargoFound == true then Object.ApplyVelocity(MyCargo,0,0,false) end
					MyHook.Pos.x = Get(this,"TmpX")
					reachedX = true
				end
				MyHook.Triggered = 2
			elseif MyHook.Pos.x < this.TmpX then
				if this.TmpX - MyHook.Pos.x > this.CraneSpeed then
					Object.ApplyVelocity(MyHook,this.CraneSpeed,0)
					if cargoFound == true then Object.ApplyVelocity(MyCargo,this.CraneSpeed,0,false) end
				elseif this.TmpX - MyHook.Pos.x > 0 then
					Object.ApplyVelocity(MyHook,this.TmpX+0.5 - MyHook.Pos.x,0)
					if cargoFound == true then Object.ApplyVelocity(MyCargo,this.TmpX+0.5 - MyHook.Pos.x,0,false) end
				else
					Object.ApplyVelocity(MyHook,0,0)
					if cargoFound == true then Object.ApplyVelocity(MyCargo,0,0,false) end
					MyHook.Pos.x = Get(this,"TmpX")
					reachedX = true
				end
			end
		end
	end
	if reachedX == true and reachedY == true then
		MyHook.SubType=0
		Set(this,"init",nil)
		Set(this,"MoveToCentre",false)
		Set(this,"MoveTheCrane",true)
		Set(MyHook,this.GiveJob,true)
		cargoFound = nil
	end
end

-------------------- Done moving -------------------------


-------------------- Create and Update -------------------------

function Create()
	Set(this,"CraneSpeed",1.5)
end

function Update(timePassed)
	if timePerUpdate == nil then
		Set(this,"Tooltip","HomeUID: "..this.HomeUID)
		FindMyCrane()
		if Get(this,"CraneInPosition") == true and Get(this,"MoveToCentre") == false and Get(this,"GiveJob") ~= nil then Set(MyHook,this.GiveJob,true) end
	end
	timeAnim = timeAnim + timePassed
	timeTot = timeTot + timePassed
	if timeTot >= timePerUpdate then
		timeTot = 0
		
		if Get(this,"MoveToCentre") == true and (this.MoveToY or 0) > 0 then
			MoveToCentre()
		elseif Get(this,"MoveTheCrane") == true and (this.MoveToY or 0) > 0 then
			MoveTheCrane()
		else
			timePerUpdate = 2 / this.TimeWarp
		end
	end
end

