
local timeTot=0
local Get=Object.GetProperty
local Set=Object.SetProperty
local Find=this.GetNearbyObjects
local group = { "Workman","Janitor","Gardener","Sniper","Cook","CarMechanic2","CraneOperator2","TowTruck2Driver","TowTruck2DriverMilitary" }
local crap = { "Garbage","Rubble","Box","Stack","UnsortedTrash" }

function Create()
	local nearbyObject = Find("StreetManager",1500)
	if next(nearbyObject) then
		for thatManager,dist in pairs(nearbyObject) do
			Set(thatManager,"FindNewMarkers",true)
			print("Update StreetManager")
		end
	end
	nearbyObject = nil
end

function FindMyTrafficLight()
	local roadlightFound = false
	local nearbyObject = Find("RoadPoleTrafficLight",2)
	if next(nearbyObject) then
		for thatLight, distance in pairs(nearbyObject) do
			if thatLight.HomeUID==this.HomeUID then
				if not thatLight.SideLaneLight then
					MyRoadTrafficLight=thatLight
					roadlightFound = true
				else
					MySideLaneTrafficLight=thatLight
					sidelightFound = true
				end
			end
		end
	end
	if roadlightFound == false then
		if this.Or.x == 0 and this.Or.y == -1 then
			MyRoadTrafficLight = Object.Spawn("RoadPoleTrafficLight",this.Pos.x-1.5,this.Pos.y)
			if this.SmallPost == nil then MyRoadTrafficLight.SubType = 2 else MyRoadTrafficLight.SubType = 0 end
			Set(MyRoadTrafficLight,"HomeUID",this.HomeUID)
			Set(MyRoadTrafficLight,"ActiveLeft",nil)
			Set(MyRoadTrafficLight,"ActiveRight",nil)
			Set(MyRoadTrafficLight,"Tooltip","Road Light")
		elseif this.Or.x == 0 and this.Or.y == 1 then
			MyRoadTrafficLight = Object.Spawn("RoadPoleTrafficLight",this.Pos.x+1.5,this.Pos.y)
			if this.SmallPost == nil then MyRoadTrafficLight.SubType = 2 else MyRoadTrafficLight.SubType = 0 end
			Set(MyRoadTrafficLight,"HomeUID",this.HomeUID)
			Set(MyRoadTrafficLight,"ActiveLeft",nil)
			Set(MyRoadTrafficLight,"ActiveRight",nil)
			Set(MyRoadTrafficLight,"Tooltip","Road Light")
		end
	end
	nearbyObject = nil
end

function ResetGateClicked()
	FindMyTrafficLight()
    local nearbyObject = Find("RoadMarker",1500)
	if next(nearbyObject) then
		for name,dist in pairs(nearbyObject) do
			if Get(this,"MarkerUID") == Get(name,"MarkerUID") then
				--print("marker found")
				MyMarker=name
				local i = Get(this,"GatePosition")
				--print("reset gate "..i)
				Set(MyMarker,"RequestFrom"..i,"none")
				Set(MyMarker,"Authorized"..i,"no")
				Set(MyMarker,"CloseGate"..i,"no")
				Set(this,"Mode",0)
			end
		end
	end
	nearbyObject = nil
end

function ScanForStaff()
	for _, typ in pairs(group) do
		local people = Find(typ,1)
		for entity, _ in pairs(people) do
			if next(entity) then
				this.Open=0.1
			end
		end
	end
	people=nil
end

function MoveStaff()
	for _, typ in pairs(group) do
		local people = Find(typ,1)
		for entity, _ in pairs(people) do
			if next(entity) then
				if entity.Pos.y >= this.Pos.y then
					entity.Pos.y = this.Pos.y-1
				else
					entity.Pos.y = this.Pos.y+1
				end
				break
			end
		end
	end
	people=nil
end

function ScanForCrap()
	for _, typ in pairs(crap) do
		local thecrap = Find(typ,1)
		for thatcrap, _ in pairs(thecrap) do
			if next(thatcrap) then
				if thatcrap.CarrierId.i == nil or thatcrap.Loaded == false then
					thatcrap.Delete()
				end
			end
		end
	end
	MoveStaff()
	thecrap=nil
end

function Update(timePassed)
	if timePerUpdate==nil then
		FindMyTrafficLight()
		Interface.AddComponent(this,"ResetGate", "Button", "Reset Gate")
		timePerUpdate=3+math.random()
		if not Get(this,"PostSpawned") then
			if not Get(this,"SmallPost") then
				leftPart=Object.Spawn("LeftPostRoadGate",this.Pos.x-1.25,this.Pos.y-0.5)
				rightPart=Object.Spawn("RightPostRoadGate",this.Pos.x+1.25,this.Pos.y-0.5)
				if this.HomeUID ~= nil then
					Set(leftPart,"HomeUID",this.HomeUID)
					Set(rightPart,"HomeUID",this.HomeUID)
				end
			else
				this.SubType = 1
			end
			Set(this,"PostSpawned",true)
		end
	end
	timeTot=timeTot+timePassed
	if timeTot>=timePerUpdate then
		timeTot=0
		if this.Mode=="Normal" and this.CloseTimer==0 then
			ScanForStaff()
		else
			ScanForCrap()
		end
	end
	if MyRoadTrafficLight ~= nil then 
		if this.Open == 0 then
			if this.Or.x == 0 and this.Or.y == -1 then
				MyRoadTrafficLight.ActiveLeft = nil
			elseif this.Or.x == 0 and this.Or.y == 1 then
				MyRoadTrafficLight.ActiveRight = nil
			end
		else
			if this.Or.x == 0 and this.Or.y == -1 then
				MyRoadTrafficLight.ActiveLeft = true
			elseif this.Or.x == 0 and this.Or.y == 1 then
				MyRoadTrafficLight.ActiveRight = true
			end
		end
		if MyRoadTrafficLight.ActiveLeft == nil and MyRoadTrafficLight.ActiveRight == nil then
			if MyRoadTrafficLight.SubType == 1 then MyRoadTrafficLight.SubType = 0 end
			if MyRoadTrafficLight.SubType == 3 then MyRoadTrafficLight.SubType = 2 end
		else
			if MyRoadTrafficLight.SubType == 0 then MyRoadTrafficLight.SubType = 1 end
			if MyRoadTrafficLight.SubType == 2 then MyRoadTrafficLight.SubType = 3 end
		end
		MyRoadTrafficLight.Tooltip = this.Tooltip
	end
	if MySideLaneTrafficLight ~= nil then MySideLaneTrafficLight.Tooltip = this.Tooltip end
end
