
local timeTot = 0
local Set = Object.SetProperty
local Get = Object.GetProperty
local Find = Object.GetNearbyObjects
local nearbyObject = {}

function FindMyCrane()
	--print("findcrane")
	nearbyObject = Find("GantryCrane2RailLeft",50)
	if next(nearbyObject) then
		for thatRail, distance in pairs(nearbyObject) do
			if thatRail.HomeUID==this.HomeUID then
				--print("MyCraneRailLeft found")
				MyCraneRailLeft=thatRail
			end
		end
	end
	nearbyObject = Find("GantryCrane2Booth",50)
	if next(nearbyObject) then
		for thatBooth, distance in pairs(nearbyObject) do
			if thatBooth.HomeUID==this.HomeUID then
				MyCraneBooth=thatBooth
				--print("MyCraneBooth found")
			end
		end
	end
	nearbyObject = nil
end

function SpawnBill(price,theNr)
	if timePerUpdate == nil then
		Init()
	end
	--print("spawn bill "..theNr.." with price "..price)
	if price == nil then price = math.random(1,10) end
	NewBill = Object.Spawn("Limo2Bill"..price,this.Pos.x,this.Pos.y)
	Set(NewBill,"CraneUID",this.HomeUID)
	local velX = -0.25 + math.random()
	local velY = -0.25 + math.random()
	Object.ApplyVelocity(NewBill, velX, velY)
	
	NewRepairPapersCopy = Object.Spawn("Limo2RepairPapersCopy",this.Pos.x,this.Pos.y)
	Set(NewRepairPapersCopy,"CraneUID",this.HomeUID)
	local velX = -0.25 + math.random()
	local velY = -0.25 + math.random()
	Object.ApplyVelocity(NewRepairPapersCopy, velX, velY)
	
	NewRepairPapers = Object.Spawn("Limo2RepairPapers",this.Pos.x,this.Pos.y)
	Set(NewRepairPapers,"CraneUID",this.HomeUID)
	Set(NewRepairPapers,"CarNr",theNr)
	local velX = -0.25 + math.random()
	local velY = -0.25 + math.random()
	Object.ApplyVelocity(NewRepairPapers, velX, velY)
	
	Object.CancelJob(this,"WriteBill"..theNr)
	Set(this,"WriteBill"..theNr,false)
	
	MyLimoDriver = Object.Spawn("Limo2Driver"..theNr,this.Pos.x,0)
	if MyCraneBooth.IsMilitary == "Yes" then
		MyLimoDriver.SubType = math.random(22,34)
	else
		MyLimoDriver.SubType = math.random(0,21)
	end
	MyLimoDriver.NavigateTo(this.Pos.x,this.Pos.y)
	Set(MyLimoDriver,"HomeUID",this.HomeUID)
	Set(MyLimoDriver,"CarUID",Get(this,"CarUID"..theNr))
	MyLimoDriver.Tooltip = "\nCarUID: "..MyLimoDriver.CarUID.."\nComing to fetch limo "..theNr+1
	
	--print("create job paybill "..theNr)
	Object.CreateJob(this,"PayBill"..theNr)
	Set(this,"PayBill"..theNr,true)
end

function PayBill(theNr)
	if timePerUpdate == nil then
		Init()
	end
	--print("finding driver "..theNr)
    local nearbyObject = Find("Limo2Driver"..theNr,500)
	if next(nearbyObject) then
		for thatEntity, distance in pairs(nearbyObject) do
			if thatEntity.HomeUID == this.HomeUID then
				--print("Driver found")
				MyLimoDriver=thatEntity
				driverFound = true
				break
			end
		end
	end
	if driverFound == true then
		local nearbyObject = Find("Limo2RepairPapers",3)
		if next(nearbyObject) then
			for thatBill, distance in pairs(nearbyObject) do
				if thatBill.CraneUID == this.HomeUID and thatBill.CarNr == theNr then
					LeavingLimoDriver = Object.Spawn("Limo2DriverLeaving",MyLimoDriver.Pos.x,MyLimoDriver.Pos.y)
					LeavingLimoDriver.SubType = MyLimoDriver.SubType
					LeavingLimoDriver.Or.x = MyLimoDriver.Or.x
					LeavingLimoDriver.Or.y = MyLimoDriver.Or.y
					Set(LeavingLimoDriver,"CarUID",Get(this,"CarUID"..theNr))
					Set(LeavingLimoDriver,"DeskX",this.Pos.x)
					Set(LeavingLimoDriver,"DeskY",this.Pos.y)
					LeavingLimoDriver.Tooltip = "\nCarUID: "..LeavingLimoDriver.CarUID.."\nPaid for limo "..theNr+1
					Set(this,"CarUID"..theNr,nil)
					MyLimoDriver.Delete()
					thatBill.Delete()
					local correctItem = "Limo2Receipt"
					for i = 57,200 do
						LeavingLimoDriver.Equipment = i
						if LeavingLimoDriver.Equipment == correctItem then
							break
						end
					end
					Set(this,"RepairBill"..theNr,0)
					Set(this,"PayBill"..theNr,false)
					Set(this,"PaymentInProgress",false)
					Set(MyCraneBooth,"ttSlot"..theNr,"Bill paid, waiting for crane...")
					Set(MyCraneBooth,"UnloadSlot"..theNr,true)
					papersFound = true
					break
				end
			end
		end
		if papersFound == nil then
			Set(this,"WriteBill"..theNr,true)
			Set(this,"PayBill"..theNr,false)
			--print("no papers found, create job writebill "..theNr)
			Object.CreateJob(this,"WriteBill"..theNr)
		end
		nearbyObject = nil
	else
		--print("Driver not found, spawn new")
		MyLimoDriver = Object.Spawn("Limo2Driver"..theNr,this.Pos.x,0)
		if MyCraneBooth.IsMilitary == "Yes" then
			MyLimoDriver.SubType = math.random(22,34)
		else
			MyLimoDriver.SubType = math.random(0,21)
		end
		MyLimoDriver.NavigateTo(this.Pos.x,this.Pos.y)
		Set(MyLimoDriver,"HomeUID",this.HomeUID)
		Set(MyLimoDriver,"CarUID",Get(this,"CarUID"..theNr))
		MyLimoDriver.Tooltip = "\nCarUID: "..MyLimoDriver.CarUID.."\nComing to fetch limo "..theNr+1
		Set(this,"PayBill"..theNr,true)
		--print("no driver found, create job paybill "..theNr)
		Object.CreateJob(this,"PayBill"..theNr)
	end
	nearbyObject = nil
end

function Create()

	Set(this,"WriteBill0",false)
	Set(this,"WriteBill1",false)
	Set(this,"WriteBill2",false)
	Set(this,"WriteBill3",false)
	Set(this,"WriteBill4",false)
	Set(this,"WriteBill5",false)
	Set(this,"WriteBill6",false)
	Set(this,"WriteBill7",false)
	Set(this,"WriteBill8",false)
	Set(this,"WriteBill9",false)
	Set(this,"WriteBill10",false)
	Set(this,"WriteBill11",false)
	Set(this,"WriteBill12",false)
	Set(this,"WriteBill13",false)
	Set(this,"WriteBill14",false)
	Set(this,"WriteBill15",false)
	Set(this,"PayBill0",false)
	Set(this,"PayBill1",false)
	Set(this,"PayBill2",false)
	Set(this,"PayBill3",false)
	Set(this,"PayBill4",false)
	Set(this,"PayBill5",false)
	Set(this,"PayBill6",false)
	Set(this,"PayBill7",false)
	Set(this,"PayBill8",false)
	Set(this,"PayBill9",false)
	Set(this,"PayBill10",false)
	Set(this,"PayBill11",false)
	Set(this,"PayBill12",false)
	Set(this,"PayBill13",false)
	Set(this,"PayBill14",false)
	Set(this,"PayBill15",false)
	Set(this,"RepairBill0",0)
	Set(this,"RepairBill1",0)
	Set(this,"RepairBill2",0)
	Set(this,"RepairBill3",0)
	Set(this,"RepairBill4",0)
	Set(this,"RepairBill5",0)
	Set(this,"RepairBill6",0)
	Set(this,"RepairBill7",0)
	Set(this,"RepairBill8",0)
	Set(this,"RepairBill9",0)
	Set(this,"RepairBill10",0)
	Set(this,"RepairBill11",0)
	Set(this,"RepairBill12",0)
	Set(this,"RepairBill13",0)
	Set(this,"RepairBill14",0)
	Set(this,"RepairBill15",0)
end

function Init()
	Set(this,"Tooltip","CraneUID: "..this.HomeUID)
	FindMyCrane()
	timePerUpdate = 5 / this.TimeWarp
end

function Update(timePassed)
	if timePerUpdate == nil then
		Init()
	end
	timeTot = timeTot + timePassed
	if timeTot >= timePerUpdate then
		timeTot = 0
		if this.WriteBill0 == true and not this.PaymentInProgress then Set(this,"PaymentInProgress",true); Object.CreateJob(this,"WriteBill0") end
		if this.WriteBill1 == true and not this.PaymentInProgress then Set(this,"PaymentInProgress",true); Object.CreateJob(this,"WriteBill1") end
		if this.WriteBill2 == true and not this.PaymentInProgress then Set(this,"PaymentInProgress",true); Object.CreateJob(this,"WriteBill2") end
		if this.WriteBill3 == true and not this.PaymentInProgress then Set(this,"PaymentInProgress",true); Object.CreateJob(this,"WriteBill3") end
		if this.WriteBill4 == true and not this.PaymentInProgress then Set(this,"PaymentInProgress",true); Object.CreateJob(this,"WriteBill4") end
		if this.WriteBill5 == true and not this.PaymentInProgress then Set(this,"PaymentInProgress",true); Object.CreateJob(this,"WriteBill5") end
		if this.WriteBill6 == true and not this.PaymentInProgress then Set(this,"PaymentInProgress",true); Object.CreateJob(this,"WriteBill6") end
		if this.WriteBill7 == true and not this.PaymentInProgress then Set(this,"PaymentInProgress",true); Object.CreateJob(this,"WriteBill7") end
		if this.WriteBill8 == true and not this.PaymentInProgress then Set(this,"PaymentInProgress",true); Object.CreateJob(this,"WriteBill8") end
		if this.WriteBill9 == true and not this.PaymentInProgress then Set(this,"PaymentInProgress",true); Object.CreateJob(this,"WriteBill9") end
		if this.WriteBill0 == true and not this.PaymentInProgress then Set(this,"PaymentInProgress",true); Object.CreateJob(this,"WriteBill10") end
		if this.WriteBill11 == true and not this.PaymentInProgress then Set(this,"PaymentInProgress",true); Object.CreateJob(this,"WriteBill11") end
		if this.WriteBill12 == true and not this.PaymentInProgress then Set(this,"PaymentInProgress",true); Object.CreateJob(this,"WriteBill12") end
		if this.WriteBill13 == true and not this.PaymentInProgress then Set(this,"PaymentInProgress",true); Object.CreateJob(this,"WriteBill13") end
		if this.WriteBill14 == true and not this.PaymentInProgress then Set(this,"PaymentInProgress",true); Object.CreateJob(this,"WriteBill14") end
		if this.WriteBill15 == true and not this.PaymentInProgress then Set(this,"PaymentInProgress",true); Object.CreateJob(this,"WriteBill15") end
		
		if this.PayBill0 == true then Object.CreateJob(this,"PayBill0") end
		if this.PayBill1 == true then Object.CreateJob(this,"PayBill1") end
		if this.PayBill2 == true then Object.CreateJob(this,"PayBill2") end
		if this.PayBill3 == true then Object.CreateJob(this,"PayBill3") end
		if this.PayBill4 == true then Object.CreateJob(this,"PayBill4") end
		if this.PayBill5 == true then Object.CreateJob(this,"PayBill5") end
		if this.PayBill6 == true then Object.CreateJob(this,"PayBill6") end
		if this.PayBill7 == true then Object.CreateJob(this,"PayBill7") end
		if this.PayBill8 == true then Object.CreateJob(this,"PayBill8") end
		if this.PayBill9 == true then Object.CreateJob(this,"PayBill9") end
		if this.PayBill10 == true then Object.CreateJob(this,"PayBill10") end
		if this.PayBill11 == true then Object.CreateJob(this,"PayBill11") end
		if this.PayBill12 == true then Object.CreateJob(this,"PayBill12") end
		if this.PayBill13 == true then Object.CreateJob(this,"PayBill13") end
		if this.PayBill14 == true then Object.CreateJob(this,"PayBill14") end
		if this.PayBill15 == true then Object.CreateJob(this,"PayBill15") end
	end
end

function JobComplete_WriteBill0()
	SpawnBill(Get(this,"RepairBill0"),0)
end

function JobComplete_PayBill0()
	PayBill(0)
end

function JobComplete_WriteBill1()
	SpawnBill(Get(this,"RepairBill1"),1)
end

function JobComplete_PayBill1()
	PayBill(1)
end

function JobComplete_WriteBill2()
	SpawnBill(Get(this,"RepairBill2"),2)
end

function JobComplete_PayBill2()
	PayBill(2)
end

function JobComplete_WriteBill3()
	SpawnBill(Get(this,"RepairBill3"),3)
end

function JobComplete_PayBill3()
	PayBill(3)
end

function JobComplete_WriteBill4()
	SpawnBill(Get(this,"RepairBill4"),4)
end

function JobComplete_PayBill4()
	PayBill(4)
end

function JobComplete_WriteBill5()
	SpawnBill(Get(this,"RepairBill5"),5)
end

function JobComplete_PayBill5()
	PayBill(5)
end

function JobComplete_WriteBill6()
	SpawnBill(Get(this,"RepairBill6"),6)
end

function JobComplete_PayBill6()
	PayBill(6)
end

function JobComplete_WriteBill7()
	SpawnBill(Get(this,"RepairBill7"),7)
end

function JobComplete_PayBill7()
	PayBill(7)
end

function JobComplete_WriteBill8()
	SpawnBill(Get(this,"RepairBill8"),8)
end

function JobComplete_PayBill8()
	PayBill(8)
end

function JobComplete_WriteBill9()
	SpawnBill(Get(this,"RepairBill9"),9)
end

function JobComplete_PayBill9()
	PayBill(9)
end

function JobComplete_WriteBill10()
	SpawnBill(Get(this,"RepairBill10"),10)
end

function JobComplete_PayBill10()
	PayBill(10)
end

function JobComplete_WriteBill11()
	SpawnBill(Get(this,"RepairBill11"),11)
end

function JobComplete_PayBill11()
	PayBill(11)
end

function JobComplete_WriteBill12()
	SpawnBill(Get(this,"RepairBill12"),12)
end

function JobComplete_PayBill12()
	PayBill(12)
end

function JobComplete_WriteBill13()
	SpawnBill(Get(this,"RepairBill13"),13)
end

function JobComplete_PayBill13()
	PayBill(13)
end

function JobComplete_WriteBill14()
	SpawnBill(Get(this,"RepairBill14"),14)
end

function JobComplete_PayBill14()
	PayBill(14)
end

function JobComplete_WriteBill15()
	SpawnBill(Get(this,"RepairBill15"),15)
end

function JobComplete_PayBill15()
	PayBill(15)
end

